Package org.springframework.web.servlet.view.feed

# Class AbstractRssFeedView

java.lang.Object
org.springframework.context.support.ApplicationObjectSupport
org.springframework.web.context.support.WebApplicationObjectSupport
org.springframework.web.servlet.view.AbstractView
org.springframework.web.servlet.view.feed.AbstractFeedView<com.rometools.rome.feed.rss.Channel>
org.springframework.web.servlet.view.feed.AbstractRssFeedView

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.context.ApplicationContextAware`, `org.springframework.web.context.ServletContextAware`, `View`

public abstract class AbstractRssFeedView extends AbstractFeedView<com.rometools.rome.feed.rss.Channel>
Abstract superclass for RSS Feed views, using the ROME package.

NOTE: As of Spring 4.1, this is based on the `com.rometools` variant of ROME, version 1.5. Please upgrade your build dependency.

Application-specific view classes will extend this class. The view will be held in the subclass itself, not in a template. Main entry points are the `AbstractFeedView.buildFeedMetadata(java.util.Map<java.lang.String, java.lang.Object>, T, jakarta.servlet.http.HttpServletRequest)` and `buildFeedItems(java.util.Map<java.lang.String, java.lang.Object>, jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse)`.

Thanks to Jettro Coenradie and Sergio Bossa for the original feed view prototype!

Since:
  3.0
Author:
  Arjen Poutsma, Juergen Hoeller
See Also:
  - `AbstractFeedView.buildFeedMetadata(java.util.Map<java.lang.String, java.lang.Object>, T, jakarta.servlet.http.HttpServletRequest)`
  - `buildFeedItems(java.util.Map<java.lang.String, java.lang.Object>, jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse)`

## Field Summary

### Fields inherited from class org.springframework.web.servlet.view.AbstractView

`DEFAULT_CONTENT_TYPE`

### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

`logger`

### Fields inherited from interface org.springframework.web.servlet.View

`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE, SELECTED_CONTENT_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractRssFeedView()`

## Method Summary

Modifier and Type
Method
Description
`protected final void`
`buildFeedEntries(Map<String,Object> model, com.rometools.rome.feed.rss.Channel channel, HttpServletRequest request, HttpServletResponse response)`
Invokes `buildFeedItems(Map, HttpServletRequest, HttpServletResponse)` to get a list of feed items.
`protected abstract List<com.rometools.rome.feed.rss.Item>`
`buildFeedItems(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)`
Subclasses must implement this method to build feed items, given the model.
`protected com.rometools.rome.feed.rss.Channel`
`newFeed()`
Create a new Channel instance to hold the entries.

### Methods inherited from class org.springframework.web.servlet.view.feed.AbstractFeedView

`buildFeedMetadata, renderMergedOutputModel`

### Methods inherited from class org.springframework.web.servlet.view.AbstractView

`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, formatViewName, generatesDownloadContent, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getRequestToExpose, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposeContextBeansAsAttributes, setExposedContextBeanNames, setExposePathVariables, setRequestContextAttribute, setResponseContentType, toString, writeToResponse`

### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

`getApplicationContext, getMessageSourceAccessor, initApplicationContext, obtainApplicationContext, requiredContextClass, setApplicationContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AbstractRssFeedView

public AbstractRssFeedView()

## Method Details

### newFeed

protected com.rometools.rome.feed.rss.Channel newFeed()
Create a new Channel instance to hold the entries.

By default returns an RSS 2.0 channel, but the subclass can specify any channel.

Specified by:
  `newFeed` in class `AbstractFeedView<com.rometools.rome.feed.rss.Channel>`
Returns:
  the newly created Feed instance

### buildFeedEntries

protected final void buildFeedEntries(Map<String,Object> model, com.rometools.rome.feed.rss.Channel channel, HttpServletRequest request, HttpServletResponse response) throws Exception
Invokes `buildFeedItems(Map, HttpServletRequest, HttpServletResponse)` to get a list of feed items.

Specified by:
  `buildFeedEntries` in class `AbstractFeedView<com.rometools.rome.feed.rss.Channel>`
Parameters:
  `model` - the model Map
  `channel` - the feed to add entries to
  `request` - in case we need locale etc. Shouldn't look at attributes.
  `response` - in case we need to set cookies. Shouldn't write to it.
Throws:
  `Exception` - any exception that occurred during building

### buildFeedItems

protected abstract List<com.rometools.rome.feed.rss.Item> buildFeedItems(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response) throws Exception
Subclasses must implement this method to build feed items, given the model.

Note that the passed-in HTTP response is just supposed to be used for setting cookies or other HTTP headers. The built feed itself will automatically get written to the response after this method returns.

Parameters:
  `model` - the model Map
  `request` - in case we need locale etc. Shouldn't look at attributes.
  `response` - in case we need to set cookies. Shouldn't write to it.
Returns:
  the feed items to be added to the feed
Throws:
  `Exception` - any exception that occurred during document building
See Also:
  - `Item`